/* dcf_control.c
 from dc fighting v0.2.4
  by
   jimbo
    Dan Potter and Jordan DeLong of Cryptic Allusion
     Andrew K.
      Marcus Comstedt



 dcf_control.c : this file contains controller->fighter linking code.
  button actions may change between players.
   new anchors may need to be added for a particular character, unless 
    'jab, 'short kick', etc. can be generalized to something like a function or macro...


 Sun Feb  3 15:08:19 EST 2002
  this code needs an enema...

 Sat Feb  9 21:01:48 EST 2002
  adding moves one by one, hoping for an easier way...

 Thu Feb 14 19:17:42 EST 2002
   added knee, mid reverse and uppercut



*/




/*** Dan Potter's code in macro form ***/
/* This weird logic is to avoid bouncing back
   and forth before the user lets go of the
   button. */
#define PRESSED( x, y ) if (!(cond.buttons & x )) { \
	if (!(y & 0x1000)) {

#define PRESSED2( x, y, z ) if (  (!(cond.buttons & x)) && \
          (!(cond.buttons & y)) ) { if (!(z & 0x1000)) {

#define DESSERP( y ) if (y == 0) y = 0x1001; else y = 0x1000; } }


/*** v0.2.1 ***/
#define   MOVE_JAB              1
#define   MOVE_REVERSE_PUNCH    2
#define   MOVE_MID_REVERSE_PUNCH  203
#define   MOVE_HOOK_PUNCH       103
#define   MOVE_TWOHAND_PUNCH    104
#define   MOVE_ELBOW_PUNCH      105
#define   MOVE_UPPERCUT_PUNCH      106


#define   MOVE_SWITCH_STANCE    3
#define   MOVE_BLOCK            4
#define   MOVE_COUNTER          5
#define   MOVE_ROUNDHOUSE_KICK  6
#define   MOVE_KNEE_KICK        7
#define   MOVE_SIDE_KICK        8
#define   MOVE_FRONT_KICK       9
#define   MOVE_MULE_KICK        10

#define   MOVE_SHOULDER_THROW   301

#define   MOVE_BLOCK            1001


#define   MOVE_BE_THROWN         9001
#define   MOVE_BE_HIT_HIGH       9002
#define   MOVE_BE_HIT_MIDDLE        9003
#define   MOVE_BE_HIT_LOW        9004

#define   MOVE_BLOCKED_ATTACK    9005
#define   MOVE_BE_COUNTERED      9006




#if 0

#define   MID_FRONT_KICK
#define   LOW_FRONT_KiCK
#define   HIGH_FRONT_KICK
#define    FOOTSWEEP
#define   SIDE_KICK
#define   ROUND_KICK

#define   UPPERCUT
#define   ELBOW
#define   REVERSE_ELBOW
#define   JUMP_KICK  s

#define KNEE  
#define CHOKE
#define   KNIFE_HAND
#define   HEAD_BUTT
#define   THROW
#define   THROW_HIP_TOSS
#define THROW_TRIP
#define MORE_THROWS

#define DODGE_LEFT
#define JUMP
#define DUCK
#define DODGE_RIGHT
#define SPIN
#define ROLL
#define FLIP
#define CARTWHEEL
#define BACK_HANDSPRING
#define FORWARD_ROLL

#endif



/* v0.2.1 : simple move->add_anchor look-up table
 *  this function allows the cpu and human players to execute the same moves
 *
 *   stamina penalty should be proportional to power of the move.
 *
 *
 *   maybe take this out and put into a dcf_moves.c file...
 *
 *
 */
void do_move( fighter_t *p, int move  ) {

  /*** v0.2.4: optionally slow moves by a stamina coefficient ***/
  int stamina_slowdown = 1.0;
  if ( use_stamina == 1 ) {
    stamina_slowdown += (1.0/500.0) * (STAMINA_MAX - p->stamina);
  }

  /*** a move? ***/
  p->default_state = FIGHT_MOVE;

  /* v0.2.4: determine limb to reduce stamina for
   *
   *
   *
   */


  switch( move ) {

  case MOVE_SWITCH_STANCE:
    p->default_state = FIGHT_MOVE;
    p->fighting_state = FIGHT_MOVE;
    p->reverse = 1 - p->reverse;
    add_anchor( p, 0.15, left_fighting_stance, FIGHT_STAND );
    break;


    /* punches
     *
     *
     *
     */
  case MOVE_JAB:
    p->stamina -= 40;
    p->default_state = FIGHT_MOVE;

#if 0
    add_partial_anchor( p, 0.10085 * stamina_slowdown, PARAMS_ALL, 
	 jab_out, FIGHT_ATTACK + FIGHT_HIGH  + FIGHT_SHORT_RANGE 
	);
    add_partial_anchor( p, 0.1, left_fighting_stance, PARAMS_ARMS, FIGHT_STAND );
#else
    add_anchor( p, 0.10085 * stamina_slowdown,
	 jab_out, FIGHT_ATTACK + FIGHT_HIGH  + FIGHT_MEDIUM_RANGE 
	);
    add_anchor( p, 0.1, left_fighting_stance, FIGHT_STAND );
#endif

    break;




  case MOVE_REVERSE_PUNCH:
    p->stamina -= 65;
    add_anchor( p, 0.05 * stamina_slowdown, left_fighting_stance, FIGHT_MOVE );
    add_anchor( p, 0.10 * stamina_slowdown, reverse_out, FIGHT_ATTACK + FIGHT_HIGH + FIGHT_MEDIUM_RANGE );
    add_anchor( p, 0.23 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;



  case MOVE_MID_REVERSE_PUNCH:
    p->stamina -= 65;
    add_anchor( p, 0.05 * stamina_slowdown, mid_reverse_chamber, FIGHT_MOVE );
    add_anchor( p, 0.10 * stamina_slowdown, mid_reverse_out, FIGHT_ATTACK + FIGHT_MIDDLE + FIGHT_MEDIUM_RANGE );
    add_anchor( p, 0.15 * stamina_slowdown, mid_reverse_chamber, FIGHT_MOVE );
    add_anchor( p, 0.15 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;



  case MOVE_UPPERCUT_PUNCH:
    p->stamina -= 65;
    add_anchor( p, 0.08 * stamina_slowdown, mid_reverse_chamber, FIGHT_MOVE );
    add_anchor( p, 0.12 * stamina_slowdown, uppercut_out, FIGHT_ATTACK + FIGHT_HIGH + FIGHT_SHORT_RANGE );
    // add_anchor( p, 0.15 * stamina_slowdown, mid_reverse_chamber, FIGHT_MOVE );
    add_anchor( p, 0.23 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;






    /* kicks
     *
     *
     *
     */
  case MOVE_SIDE_KICK:
    p->stamina -= 95;
    add_anchor( p, 0.2 * stamina_slowdown, sidekick_chamber, FIGHT_MOVE );
    add_anchor( p, 0.04 * stamina_slowdown, sidekick_out, FIGHT_ATTACK + FIGHT_HIGH + FIGHT_MEDIUM_RANGE );
    add_anchor( p, 0.2 * stamina_slowdown, sidekick_chamber, FIGHT_MOVE );
    add_anchor( p, 0.1 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;





  case MOVE_MULE_KICK:
    p->stamina -= 95;
    add_anchor( p, 0.2 * stamina_slowdown, edkick3, FIGHT_MOVE );
    add_anchor( p, 0.04 * stamina_slowdown, edkick_out1, FIGHT_ATTACK + FIGHT_MIDDLE + FIGHT_MEDIUM_RANGE );
    add_anchor( p, 0.2 * stamina_slowdown, edkick3, FIGHT_MOVE );
    add_anchor( p, 0.1 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;



  case MOVE_KNEE_KICK:
    p->stamina -= 45;
    add_anchor( p, 0.05 * stamina_slowdown, left_fighting_stance, FIGHT_MOVE );
    add_anchor( p, 0.1 * stamina_slowdown, knee_out, FIGHT_ATTACK + FIGHT_MIDDLE + FIGHT_SHORT_RANGE );
    add_anchor( p, 0.1 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;










  case MOVE_BLOCK:
    add_anchor( p, 0.05 * stamina_slowdown, blocking, FIGHT_DEFENSE + FIGHT_BLOCK );
    p->default_state = FIGHT_BLOCK;
    break;


  case MOVE_COUNTER:
    add_anchor( p, 0.07, counter_out, FIGHT_DEFENSE + FIGHT_COUNTER );
    add_anchor( p, 0.15, left_fighting_stance, FIGHT_STAND );
    break;










    /* hits
     *
     *
     *
     */
  case MOVE_BE_HIT_HIGH:  
    p->fighting_state -= 10; //= FIGHT_STUNNED;
    p->default_state -= 10; //= FIGHT_STUNNED;
    add_anchor( p, 0.05, stagger_high_hit, p->fighting_state + 10 ); // FIGHT_STUNNED );
    add_anchor( p, 0.35, stagger_high_hit2, p->fighting_state + 10 ); // FIGHT_STAND );
    break;



  case MOVE_BE_HIT_MIDDLE:  
    p->fighting_state -= 10; //= FIGHT_STUNNED;
    p->default_state -= 10; //= FIGHT_STUNNED;
    add_anchor( p, 0.05, stagger_mid_hit, p->fighting_state + 10 ); // FIGHT_STUNNED );
    add_anchor( p, 0.35, stagger_mid_hit2, p->fighting_state + 10 ); // FIGHT_STAND );
    break;

  case MOVE_BE_COUNTERED: 
    p->fighting_state -= 10; //= FIGHT_STUNNED;
    p->default_state -= 10; //= FIGHT_STUNNED;
    add_anchor( p, 0.05, stagger_high_hit, p->fighting_state + 10 ); // FIGHT_STUNNED );
    add_anchor( p, 0.35, stagger_high_hit2, p->fighting_state + 10 ); // FIGHT_STAND );
    break;





  case MOVE_SHOULDER_THROW:
    p->stamina -= 90;
    p->default_state = FIGHT_MOVE;
    add_anchor( p, 0.1, left_fighting_stance, FIGHT_MOVE );
    add_anchor( p, 0.1, twohand_chamber, FIGHT_MOVE );
    add_anchor( p, 0.2, twohand_push, FIGHT_ATTACK + FIGHT_THROW + FIGHT_MIDDLE );
    add_anchor( p, 0.4, left_fighting_stance, FIGHT_STAND );
    break;




  case MOVE_BE_THROWN:  
    p->fighting_state = FIGHT_DOWN;
    p->default_state = FIGHT_DOWN;
    add_anchor( p, 0.15, fallen_down, 10 );
    add_anchor( p, 0.35, lying_down, 10 );
    break;


















#if 0

  case MOVE_HOOK_PUNCH:
    p->stamina -= 70;
    add_anchor( p, 0.13 * stamina_slowdown, punch_windup, FIGHT_MOVE );
    add_anchor( p, 0.13 * stamina_slowdown, reverse_out, FIGHT_ATTACK + FIGHT_HIGH + FIGHT_SHORT_RANGE );
    add_anchor( p, 0.2 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;

  case MOVE_TWOHAND_PUNCH:
    p->stamina -= 80;
    add_anchor( p, 0.4 * stamina_slowdown, twohand_chamber, FIGHT_MOVE );
    add_anchor( p, 0.15 * stamina_slowdown, twohand_push, FIGHT_ATTACK + FIGHT_HIGH + FIGHT_SHORT_RANGE );
    add_anchor( p, 0.3 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;

  case MOVE_ELBOW_PUNCH:
    p->stamina -= 50;
    add_anchor( p, 0.2 * stamina_slowdown, twohand_chamber, FIGHT_MOVE );
    add_anchor( p, 0.1 * stamina_slowdown, elbow_connect2, FIGHT_ATTACK + FIGHT_HIGH + FIGHT_SHORT_RANGE );
    add_anchor( p, 0.25 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;

  case MOVE_ROUNDHOUSE_KICK:
    p->default_state = FIGHT_MOVE;
    p->stamina -= 65;
    add_anchor( p, 0.1 * stamina_slowdown, round_kick_outside4, FIGHT_MOVE );
    add_anchor( p, 0.01 * stamina_slowdown, round_kick_connect3, FIGHT_ATTACK + FIGHT_MIDDLE + FIGHT_LONG_RANGE );
    add_anchor( p, 0.025 * stamina_slowdown, round_kick_outside4, FIGHT_MOVE );
    add_anchor( p, 0.125 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;

  case MOVE_FRONT_KICK:
    p->stamina -= 65;
    add_anchor( p, 0.1 * stamina_slowdown, frontkick_chamber2, FIGHT_MOVE );
    add_anchor( p, 0.05 * stamina_slowdown, frontkick_connect, FIGHT_ATTACK + FIGHT_MIDDLE + FIGHT_MEDIUM_RANGE );
    add_anchor( p, 0.1 * stamina_slowdown, frontkick_chamber, FIGHT_MOVE );
    add_anchor( p, 0.1 * stamina_slowdown, left_fighting_stance, FIGHT_STAND );
    break;

#endif







  default: break;

  }

	  
}










/* play the CPU 
 *
 *
 */
void random_input( fighter_t *p ) {
  int choice = rand() % 15;

  /*** no stamina, no move ***/
  if ( p->stamina < minimum_stamina ) { return; }

  /*** v0.1.8: slow moves by a stamina coefficient ***/
  int stamina_slowdown = 1.0 + stamina_coeffiecient * (STAMINA_MAX - p->stamina);

  if ( p->fighting_state <= FIGHT_STAND )
  if ( p->lists_in_future == 0 )
  switch( choice ) {
    
  case 0: 
    do_move( p, MOVE_COUNTER );
    break;
  case 1:
    do_move( p, MOVE_JAB );
    break;
  case 2:
    do_move( p, MOVE_REVERSE_PUNCH );
    break;
  case 3:
    do_move( p, MOVE_MID_REVERSE_PUNCH );
    break;
  case 4:
    do_move( p, MOVE_UPPERCUT_PUNCH );
    break;

  case 5:
    do_move( p, MOVE_MULE_KICK );
    break;
  case 6:
    do_move( p, MOVE_KNEE_KICK );
    break;
  case 7:
    do_move( p, MOVE_SIDE_KICK );
    break;
  case 8:
    do_move( p, MOVE_FRONT_KICK );
    break;

    /*** recenter ***/
  case 9:
    line_up_opponent( p );

    break;






  default: break;
  }
}



/* process_input2: take controller states and analyze them, adding the appropriate moves
 *  via the do_move(int move) function.
 *
 *  try again - not being such a smartass with the logic 
 *
 *
 */
void process_input2( fighter_t *p, cont_cond_t cond ) {
  int hit_a_and_x = 0;
  float control_invert = 1.0;


  /*** v0.1.6 ***/
  int towards = CONT_DPAD_RIGHT;
  int away = CONT_DPAD_LEFT;
  int up_but = CONT_DPAD_UP;
  int down_but = CONT_DPAD_DOWN;

  /*** v0.1.8: slow moves by a stamina coefficient ***/
  int stamina_slowdown = 1.0 + (1.0/300.0) * (STAMINA_MAX - p->stamina);
  

  /*** v0.1.9 ***/
  double toward_vector[4];
  double toward_vector_norm;
  






  /*** v0.1.5: control inversion a little hacky for now ***/
  if ( p == player2 ) { 
    control_invert = -1.0; 
    towards = CONT_DPAD_LEFT;
    away = CONT_DPAD_RIGHT;

    up_but = CONT_DPAD_DOWN;
    down_but = CONT_DPAD_UP;

  }




  
  /*** hold both triggers for debug mode ***/
  if ( ( cond.rtrig > 0 ) && ( cond.ltrig > 0 ) ){


    if (!(cond.buttons & CONT_DPAD_UP)) {
      p->params[42] += 0.15;
      return;
    }
    if (!(cond.buttons & CONT_DPAD_DOWN)) {
      p->params[42] -= 0.15;
    }

    if (!(cond.buttons & CONT_DPAD_LEFT)) {
      p->params[41] += 0.15;
    }
    if (!(cond.buttons & CONT_DPAD_RIGHT)) {
      p->params[41] -= 0.15;
    }

    return;



  }  /*** holding both triggers ***/




  /* v0.1.8: special move code here
   *
   *
   *  does it count for the move if already doing a move?
   *   well see.
   *
   *
   */

  /*** Log event to history ***/
  p->controller_history[ p->history_pointer++ ] = cond.buttons;
  p->history_pointer %= HISTORY_SIZE;
  
  /*** this one only logs new DIFFERENT states ***/
  if ( MOVE_AGO( 1 ) != cond.buttons ) {
    p->change_history[ p->change_pointer++ ] = cond.buttons;
    p->change_pointer %= HISTORY_SIZE;
  }


  /* EZblock code block would go here - 
   *   just hold block for defense
   *
   *
   */


  
  /*** already doing a move ***/
  if ( p->lists_in_future > 0 ) { return; }
  
  /*** no stamina, no move ***/
  if ( p->stamina < minimum_stamina ) { return; }






#if 0
  /*** v0.1.7: if on the ground, add intermediate moves to get up ***/
  if ( cond.buttons != 65535 )
  if ( p->default_state < FIGHT_STAND ) {
    // if ( p->fighting_state < FIGHT_KNEEL ) {
    printf("cond.buttons: %d\n", cond.buttons );
    p->default_state = FIGHT_MOVE;
    add_anchor( p, 0.42, kneeling_stance, FIGHT_MOVE );
    add_anchor( p, 0.42, left_fighting_stance, FIGHT_STAND );

  }

#endif

  




#if 0


  /* v0.2.0: sample of move history detection
   *
   *
   */
  if (!(MOVE_AGO( 1 ) & CONT_A)) {
    if (!(MOVE_AGO( 2 ) & towards)) {
      if ((MOVE_AGO( 3 ) & towards)) {
	if (!(MOVE_AGO( 4 ) & towards)) {
	  printf("t-towards A!!\n");
	}
      }
    }
  }
  
#endif


  
  /*** motion v0.1.8:
   *     time to hack this up right.
   *     - test against the walls
   *     - manipulate fighter's xyz directly, or add an anchor?
   *
   */



  if (!(cond.buttons & towards)) {
    
    /*** v0.1.9: check for double click condition 
     *
     *
     */
    double coeff = 1.0;
    if (   !( MOVE_AGO(1) & CONT_B ) )
      if ( !( MOVE_AGO(2) & CONT_A )    ) {
	coeff = 2.0;
	printf("AB!!!\n");
      }
    

    toward_vector[0] = ( (fighter_t*)(p->opponent) )->position[0] - p->position[0];
    toward_vector[1] = ( (fighter_t*)(p->opponent) )->position[1] - p->position[1];
    toward_vector[2] = ( (fighter_t*)(p->opponent) )->position[2] - p->position[2];


    toward_vector_norm = 
      toward_vector[0]*toward_vector[0] + 
      toward_vector[1]*toward_vector[1] + 
      toward_vector[2]*toward_vector[2];
    
    
    
    /*** too close - cant move in ***/
    if ( toward_vector_norm > 15.0 ) {
      toward_vector[0] /= toward_vector_norm;
      toward_vector[1] /= toward_vector_norm;
      toward_vector[2] /= toward_vector_norm;
      
      p->position[0] += towardstep_length * coeff * toward_vector[0];
      p->position[1] += towardstep_length * coeff * toward_vector[1];
      p->position[2] += towardstep_length * coeff * toward_vector[2];
      
      
    }
    
    
  }
  
  
  if (!(cond.buttons & away)) {
    
    

    toward_vector[0] = ( (fighter_t*)(p->opponent) )->position[0] - p->position[0];
    toward_vector[1] = ( (fighter_t*)(p->opponent) )->position[1] - p->position[1];
    toward_vector[2] = ( (fighter_t*)(p->opponent) )->position[2] - p->position[2];


      toward_vector_norm = 
	toward_vector[0]*toward_vector[0] + 
	toward_vector[1]*toward_vector[1] + 
	toward_vector[2]*toward_vector[2];


      toward_vector[0] /= toward_vector_norm;
      toward_vector[1] /= toward_vector_norm;
      toward_vector[2] /= toward_vector_norm;

      /*** move away ***/
      p->position[0] -= towardstep_length * toward_vector[0];
      p->position[1] -= towardstep_length * toward_vector[1];
      p->position[2] -= towardstep_length * toward_vector[2];
      

      
  }
  
  








  if ( cond.ltrig == 0 ){
    double towards_vec[4];
    double up[4] = { 0.0, 1.0, 0.0, 1.0 };
    double cross_prod[4];
    double toward_norm;
    double xdot, zdot;
    double xaxis[] = {1.0,0.0,0.0};
    double zaxis[] = {0.0,0.0,1.0};
    
    /* add cross product of up and towards
     *
     *
     */
    towards_vec[0] = ( (fighter_t*)(p->opponent) )->position[0] - p->position[0];
    towards_vec[1] = ( (fighter_t*)(p->opponent) )->position[1] - p->position[1];
    towards_vec[2] = ( (fighter_t*)(p->opponent) )->position[2] - p->position[2];


    toward_norm = sqrt(
      towards_vec[0] * towards_vec[0] +
      towards_vec[1] * towards_vec[1] +
      towards_vec[2] * towards_vec[2]
      );

    towards_vec[0] /= toward_norm;
    towards_vec[1] /= toward_norm;
    towards_vec[2] /= toward_norm;

    cross_product( up, towards_vec, cross_prod );
    
   


    /* v0.1.9 : direction calculation
     *  dot p1p2 vector with x, then z
     *   take -atan2(xdot,zdot)
     *    good.
     */
    xdot = dot_product( towards_vec, xaxis );
    zdot = dot_product( towards_vec, zaxis );






    /* v0.1.5: relative rotation: this is crucial, this is where the sidestep happens.
     *   rotate the world around the fighters, and
     *    rotate them around their centers
     */
    if (!(cond.buttons & up_but)) {

      p->position[0] -= sidestep_length * cross_prod[0];
      p->position[1] -= sidestep_length * cross_prod[1];
      p->position[2] -= sidestep_length * cross_prod[2];

      p->opponent_rotation = -atan2( xdot, zdot );
    }

    if (!(cond.buttons & down_but)) {

      p->position[0] += sidestep_length * cross_prod[0];
      p->position[1] += sidestep_length * cross_prod[1];
      p->position[2] += sidestep_length * cross_prod[2];

      p->opponent_rotation = -atan2( xdot, zdot );
    }


  }






  
  /*** v0.1.6: duck if left trigger held ***/
  else {
    



    /*** LTriggerUp - jump ***/
    if (!(cond.buttons & CONT_DPAD_UP)) {
	  add_anchor( p, 0.2, jump_up, FIGHT_STAND );
	  add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
    }
	
    
    /*
      
      Unhandled exception: PC 8c011b18, code 1, evt 0120
      R0-R7: 000020a0 00000000 00000027 8c03df3c 00000800 00000040 8c0632a8 fffffffa
      R8-R15: 00000020 8c0670a4 0000003d 8c03df2c 8c012ce0 8c012cc0 8c03de28 8cffff94
      SR 40000001 PR 8c0126c0
      unhandled IRQ/Exception
      arch: shutting down kernel
      vid_set_mode: 640x480IL NTSC

      ducking causes an error...
      probably the logic to detect the release.

    */
    
#if 0
    
    player1->transrtrig = 0;
    printf("ptd %d %d   %d\n", player1->transdown ,player2->transdown , p->transrtrig);
    /*** LtriggerDown - duck ***/
    //	if (!(cond.buttons & CONT_DPAD_DOWN)) {	  
    PRESSED( CONT_DPAD_DOWN, p->transdown )
      
      if ( p->ducking == 0 ) {
	add_anchor( p, 0.2, kneeling_stance, FIGHT_STAND );
	// add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	p->ducking = 1;
      }
    
    
    DESSERP( p->transdown )
      else {
	/*** logic applied to detect Down button release ***/
	if ( p->transdown >= 0x1000 ) {
	  add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	  p->default_state = FIGHT_STAND;
	  p->ducking = 0;
	  
	}
	p->transdown &= ~0x1000;
      }
    
    
   
#endif



#if 0
    
    /* v0.1.8 : try better ducking logic here
     *

     Unhandled exception: PC 8c011ef2, code 1, evt 0120
     R0-R7: 000001b8 00000000 00000004 00000006 8c09edc8 00000060 fffffffc 8c079adc
     R8-R15: 8c09f6c4 00000023 8c079acc 8c075d30 8c079a48 8c079ad0 8c013c80 8cffff88
     SR 40000001 PR 8c012608
     unhandled IRQ/Exception
     arch: shutting down kernel
     vid_set_mode: 640x480 NTSC



     second try -  no dice.

     *
     *
     */
    if (!(cond.buttons & CONT_DPAD_DOWN)) {
      /*** if standing, duck ***/
      if ( p->ducking == 0 ) {
	add_anchor( p, 0.2, kneeling_stance, FIGHT_STAND );
	p->default_state = FIGHT_STAND;
	p->ducking = 1;
      }
    }
    else {
      /*** if ducking, stand ***/
      if ( p->ducking == 1 ) {
	add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	p->default_state = FIGHT_STAND;
	p->ducking = 0;
      }

    }


#endif



    
  }



  /* v0.1.7: throw : hold right trigger and press B
   *
   *
   */
  if ( cond.rtrig > 0 ) {
    PRESSED( CONT_B, p->transb )

	  do_move( p, MOVE_SHOULDER_THROW );
  
    DESSERP( p->transb ) 
    /*** B was not pressed ***/
    else {
      p->transb &= ~0x1000;
    }
  }




  /* A + X Buttons : reverse stance
   *
   *
   */
  PRESSED2( CONT_A, CONT_X, p->transab )

       /*** so we can tell later ***/
       hit_a_and_x = 1;
       do_move( p, MOVE_SWITCH_STANCE );

  DESSERP(  p->transab )
    /*** not A&B ***/
    else {
      p->transab &= ~0x1000;
    }
  
  
  
  /* B button: jab, quick shot
   *
   *
   *
   */
  PRESSED( CONT_B, p->transb )

      do_move( p, MOVE_JAB );

  DESSERP( p->transb ) 
    /*** B was not pressed ***/
    else {
      p->transb &= ~0x1000;
    }
      


  /*** check for X+A - dont add another punch ***/    
  if( hit_a_and_x == 0 ) {
    
    /* A button: defense
     *  - parry/counter with a direction
     *  - block with pad neutral
     */
    PRESSED( CONT_A, p->transa )
        // crap
        p->default_state = FIGHT_MOVE;
    
        if (!(cond.buttons & towards)) {
	  do_move( p, MOVE_COUNTER );
	}
	/*** A : block ***/
	else {
	  do_move( p, MOVE_BLOCK );
	}
	
    DESSERP( p->transa )
      /*** A was not pressed ***/
      else {
	
	p->default_state = FIGHT_STAND;
	
	/*** logic applied to detect A button release ***/
	if ( p->transa >= 0x1000 ) {
	  add_anchor( p, 0.2, left_fighting_stance, FIGHT_STAND );
	  p->default_state = FIGHT_STAND;
	}
	p->transa &= ~0x1000;
      }



    
    /* X button: reverse attack
     * - check direction for modifiers
     *    block, parry, counter...
     *
     */
    PRESSED( CONT_X, p->transx )


      //crap
        p->default_state = FIGHT_MOVE;
    
	if (!(cond.buttons & towards)) {
	  //  do_move( p, MOVE_HOOK_PUNCH );
	  do_move( p, MOVE_REVERSE_PUNCH );
	}
	else if (!(cond.buttons & CONT_DPAD_DOWN)) {
	  do_move( p, MOVE_MID_REVERSE_PUNCH );
	}
	else if (!(cond.buttons & CONT_DPAD_UP)) {
	  do_move( p, MOVE_UPPERCUT_PUNCH );
	}
	else if (!(cond.buttons & away)) {
	  do_move( p, MOVE_ELBOW_PUNCH );
	}
        /*** no direction ***/
	else {
	  do_move( p, MOVE_REVERSE_PUNCH );
	}


    DESSERP( p->transx )
    /*** X was not pressed ***/
    else {
      p->transx &= ~0x1000;
    }



  } /*** no X+A combo ***/


  /* Y button - kicks
   *
   */
  PRESSED( CONT_Y, p->transy )
    //crap
      p->default_state = FIGHT_MOVE;
  
      if (!(cond.buttons & towards)) {
	do_move( p, MOVE_ROUNDHOUSE_KICK );
      }
      else if (!(cond.buttons & CONT_DPAD_DOWN)) {
	do_move( p, MOVE_KNEE_KICK );
      }
      else if (!(cond.buttons & away)) {
	do_move( p, MOVE_MULE_KICK );
      }
      /*** Y no direction ***/
      else {
	do_move( p, MOVE_SIDE_KICK );
	//do_move( p, MOVE_FRONT_KICK );
      }
        
  DESSERP( p->transy )
    /*** Y was not pressed ***/
    else {
      p->transy &= ~0x1000;
    }
    
  

  
}
 




/* v0.2.2: menu control
 *
 *
 */
void process_menu_input( fighter_t *p, cont_cond_t cond ) {
  int menu_option_count = 6;



  PRESSED( CONT_DPAD_UP, p->transup )

    // if ( menu_selection > 0 )
      menu_selection--;
      menu_selection += menu_option_count;
      menu_selection %= menu_option_count;


  DESSERP( p->transup ) 
    else {
      p->transup &= ~0x1000;
    }


  PRESSED( CONT_DPAD_DOWN, p->transdown )
    /*
     * number of menu items here - bound check for pointer
     *
     *
     */
    //    if ( menu_selection < menu_option_count )
      menu_selection++;
      menu_selection %= menu_option_count;
  
  DESSERP( p->transdown ) 
    else {
      p->transdown &= ~0x1000;
    }





  PRESSED( CONT_B, p->transb )
    // menu_selection++;
  DESSERP( p->transb ) 
    /*** Y was not pressed ***/
    else {
      p->transb &= ~0x1000;
    }


  PRESSED( CONT_X, p->transx )
    //    menu_selection--;

    /*** take action ***/
    switch( menu_selection ) {
      /*
       *
       * camera follow :
       *  mod by three to keep camera_follow in bounds
       *    (four camera modes)
       *
       */
    case 0:
      camera_follow--;
      camera_follow += 4;
      camera_follow %= 4;
      break;
      
    default: break;
    }
    



  DESSERP( p->transx ) 
    /*** Y was not pressed ***/
    else {
      p->transx &= ~0x1000;
    }






  PRESSED( CONT_A, p->transa )


    /*** take action ***/
    switch( menu_selection ) {
      /*
       *
       * camera follow :
       *  mod by three to keep camera_follow in bounds
       *    (four camera modes)
       *
       */
    case 0:
      camera_follow++;
      camera_follow %= 4;
      break;
      
      /***  ***/
    case 1:
      block_damage = 1 - block_damage;
      break;

      /*** ***/
    case 2:
      display_frame_rate = 1 - display_frame_rate;
      break;

     /*** ***/
    case 3:
      use_stamina = 1 - use_stamina;
      break;


    /*** switch number of players ***/
    case 4:
      switch( player_count ) {
      case 2: player_count = 1;  break;
      case 1: 
	if ( controller_count >= 2 ) {
	  player_count = 2;
	}
	break;

      }
      break;


     /*** ***/
    case 5:
      reset_fight();
      break;

    default: break;
    }
    


  DESSERP( p->transa ) 
    /*** Y was not pressed ***/
    else {
      p->transa &= ~0x1000;
    }


}
